/*
xGL:Geometry.h
Created by mantis on 14/07/05.
Copyright 2005 xonko interactive. All rights reserved.
*/

#import <Cocoa/Cocoa.h>
#import "geometryLib.h"

@interface XGLGeometry : NSObject {

	id geometryType;
	unichar geoType;
	
	GLfloat cubeIndexedVerts[8][8];
	GLubyte cubeFaceIndexes[24];
	
	GLfloat icosahedronIndexedVerts[12][3];
	GLubyte icosahedronFaceIndexes[20][3];
	
	GLuint displayList;
	
	GLUquadric* quadObj;
	
	//quadric sphere
	GLdouble radius;
	GLint slices;
	GLint stacks;
	
	//quadric cylinder
	GLdouble base;
	GLdouble top;
	GLdouble height;
	
	//quadric disc
	GLdouble loops;
	GLdouble inner;
	GLdouble outer;
	

	BOOL animating;
	bool useVertexArrays;
	NSString *name;
	
	BOOL isParticleSystem;
	
	//NSArray *geometryTypes;
}

//+(Class)class;
+(NSArray *)geometryTypes;

-(id)init;

-(id)geometryType;
-(void)setGeometryType:(id)newGeometryType;		

-(void)drawGeometry;

-(bool)useVertexArrays;
-(void)toggleVertexArrays;

-(BOOL)animating;
-(void)setAanimating:(BOOL)newAnimating;

//-(void)toggleAnimation;
-(void)setNumParticles:(int)newNumParticles;

-(void)setupCubeArrays;
-(void)generateQuadric;

-(NSString *)name;
-(void)setName:(NSString *)aName;

-(BOOL)isParticleSystem;
-(void)setIsParticleSystem:(BOOL)value;


@end
