//
//  XGLTextureLayer.h
//  xGL2
//
//  Created by mantis on 3/08/05.
//  Copyright 2005 xonko interactive. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "XGLTexture.h"

@interface XGLTextureLayer : NSObject {

	float blendLevel;
	NSString *blendMode;
	NSString *srcBlendFunc;
	NSString *dstBlendFunc;
	
	BOOL enabled;
	BOOL reflective;
	
	NSString *name;
	
	XGLTexture *texture;
	
	GLuint xglBlendMode;
	GLuint xglsrcBlendFunc;
	GLuint xgldstBlendFunc;
}


+(NSArray *)blendModes;
+(NSArray *)srcBlendFuncs;
+(NSArray *)dstBlendFuncs;
//+(Class)class;
//-(id)init;
-(id)initWithTexture:(XGLTexture *)aTexture;

-(XGLTexture *)texture;
-(void)setTexture:(XGLTexture *)value;

-(void)setBlendLevel:(float)level;
-(float)blendLevel;

-(BOOL)enabled;
-(void)setEnabled:(BOOL)newEnabled;

-(BOOL)reflective;
-(void)setReflective:(BOOL)onOff;

-(NSString *)name;
-(void)setName:(NSString *)aName;

-(NSString *)blendMode;
-(void)setBlendMode:(NSString *)newMode;

- (NSString *)srcBlendFunc;
- (void)setSrcBlendFunc:(NSString *)value;

- (NSString *)dstBlendFunc;
- (void)setDstBlendFunc:(NSString *)value;



-(void)bindLayer;

@end
